<?php
/*
 *
 *
 */

class Contribution
{

	var $ctbt_id;
	var $ctbt_type;
	var $ctbt_state;
	var $ctbt_title;
	var $ctbt_author;
	var $ctbt_realname;
	var $ctbt_class;
	var $ctbt_teacher;

	function Contribution()
	{
	}

	function return_false(){return false;}

	function RetrieveContribution($ctbt_id)
	{
		global $xoopsDB, $xoopsModuleConfig;

		$rs = array();
		$sql = "Select " . $xoopsDB -> prefix("ctbt_contributions") . ".ctbt_id, " . $xoopsDB -> prefix("ctbt_contributions") . ".ctbt_state, " . $xoopsDB -> prefix("ctbt_contributions") . ".ctbt_type, " . $xoopsDB -> prefix("ctbt_contributions") . ".ctbt_title, " . $xoopsDB -> prefix("ctbt_contributions") . ".ctbt_author, " . $xoopsDB -> prefix("ctbt_contributions") . ".ctbt_realname, " . $xoopsDB -> prefix("ctbt_contributions") . ".ctbt_idno, " . $xoopsDB -> prefix("ctbt_contributions") . ".ctbt_address, " . $xoopsDB -> prefix("ctbt_contributions") . ".ctbt_class, " . $xoopsDB -> prefix("ctbt_contributions") . ".ctbt_comment, " . $xoopsDB -> prefix("ctbt_contributions") . ".ctbt_teacher, " . $xoopsDB -> prefix("users") . ".uname as ctbt_teacher_uname, " . $xoopsDB -> prefix("ctbt_contributions") . ".ctbt_dttm, " . $xoopsDB -> prefix("ctbt_contributions") . ".ctbt_exam_dttm";
		$sql .= " From " . $xoopsDB -> prefix("ctbt_contributions") . " Left Join " . $xoopsDB -> prefix("users") . " On " . $xoopsDB -> prefix("ctbt_contributions") . ".ctbt_teacher = " . $xoopsDB -> prefix("users") . ".uid";
		$sql .= " Where " . $xoopsDB -> prefix("ctbt_contributions") . ".ctbt_id = '" . $ctbt_id . "'";
		$result = $xoopsDB -> query($sql) or return_false();
		$rs = $xoopsDB -> fetchArray($result);

		switch ($rs['ctbt_type'])
		{
			case "txt":
				$sql = "Select txt_manuscript, txt_contribution From " . $xoopsDB -> prefix("ctbt_txt") . " Where ctbt_id = '" . $ctbt_id . "'";
				$result = $xoopsDB -> query($sql) or return_false();
				list($rs['ctbt_manuscript'], $rs['ctbt_contribution']) = $xoopsDB -> fetchRow($result);
				break;
			case "img":
				$sql = "Select img_contribution From " . $xoopsDB -> prefix("ctbt_img") . " Where ctbt_id = '" . $ctbt_id . "'";
				$result = $xoopsDB -> query($sql) or return_false();
				list($rs['ctbt_contribution']) = $xoopsDB -> fetchRow($result);
				break;
		}

		// add display datas
		$rs['ctbt_state_display'] = ($rs['ctbt_state'] == 0) ? _MD_CTBT_EXAM_STAY : (($rs['ctbt_state'] == 1) ? _MD_CTBT_EXAM_EXAMINING : (($rs['ctbt_state'] == 3) ? _MD_CTBT_EXAM_PASS : _MD_CTBT_EXAM_NOPASS));
		$rs['ctbt_type_display'] = ($rs['ctbt_type'] == "img") ? _MD_CTBT_CTBTS_LCS_IMG : _MD_CTBT_CTBTS_LCS_TXT;
		$rs['ctbt_comment_display'] = "<p>" . str_replace("\r\n", "<p><p>", htmlspecialchars($rs['ctbt_comment'])) . "</p>";
		$rs['ctbt_contribution_display'] = ($rs['ctbt_type'] == "img") ? (XOOPS_URL . $xoopsModuleConfig['uploadpath'] . "/" . $rs['ctbt_contribution']) : ("<p>" . str_replace("\r\n", "<p><p>", htmlspecialchars($rs['ctbt_contribution'])) . "</p>");
		$rs['ctbt_class_display'] = str_replace("-", _MD_CTBT_SBMT_CLASS_G, $rs['ctbt_class']) . _MD_CTBT_SBMT_CLASS_C;

		return $rs;
	}

	function ListContributions($bgn = 0, $num = 20, $condition)
	{
		global $xoopsDB, $xoopsUser;

		$rs = array();
		$sql = "Select " . $xoopsDB -> prefix("ctbt_contributions") . ".ctbt_id, " . $xoopsDB -> prefix("ctbt_contributions") . ".ctbt_state, " . $xoopsDB -> prefix("ctbt_contributions") . ".ctbt_type, " . $xoopsDB -> prefix("ctbt_contributions") . ".ctbt_title, " . $xoopsDB -> prefix("ctbt_contributions") . ".ctbt_author, " . $xoopsDB -> prefix("ctbt_contributions") . ".ctbt_realname, " . $xoopsDB -> prefix("ctbt_contributions") . ".ctbt_teacher, " . $xoopsDB -> prefix("users") . ".uname as ctbt_teacher_uname, " . $xoopsDB -> prefix("ctbt_contributions") . ".ctbt_dttm";
		$sql .= " From " . $xoopsDB -> prefix("ctbt_contributions") . " Left Join " . $xoopsDB -> prefix("users") . " On " . $xoopsDB -> prefix("ctbt_contributions") . ".ctbt_teacher = " . $xoopsDB -> prefix("users") . ".uid";
		switch ($condition)
		{
			case "admin":
				$sql .= " Order By " . $xoopsDB -> prefix("ctbt_contributions") . ".ctbt_dttm DESC";
				break;
			case "teacher":
				$uid = (is_object($xoopsUser)) ? $xoopsUser->getVar('uid') : -1;
				$sql .= " Where " . $xoopsDB -> prefix("ctbt_contributions") . ".ctbt_teacher = '" . $uid . "' Order By " . $xoopsDB -> prefix("ctbt_contributions") . ".ctbt_dttm DESC";
				break;
			default:
				$sql .= " Where " . $xoopsDB -> prefix("ctbt_contributions") . ".ctbt_state = '3' Order By " . $xoopsDB -> prefix("ctbt_contributions") . ".ctbt_exam_dttm DESC";
				break;
		}
		$sql .= " Limit " . $bgn . ", " . $num;
		$result = $xoopsDB -> query($sql) or return_false();
		while($record = $xoopsDB -> fetchArray($result))
		{
			$record['ctbt_state_display'] = ($record['ctbt_state'] == 0) ? _MD_CTBT_EXAM_STAY : (($record['ctbt_state'] == 1) ? _MD_CTBT_EXAM_EXAMINING : (($record['ctbt_state'] == 3) ? _MD_CTBT_EXAM_PASS : _MD_CTBT_EXAM_NOPASS));
			$record['ctbt_type_display'] = ($record['ctbt_type'] == "img") ? _MD_CTBT_CTBTS_LCS_IMG : _MD_CTBT_CTBTS_LCS_TXT;
			array_push($rs, $record);
		}
		return $rs;
	}

	function CountContributions($condition)
	{
		global $xoopsDB, $xoopsUser;
		$count = 0;
		$sql = "Select count(*) From " . $xoopsDB -> prefix("ctbt_contributions");
		switch ($condition)
		{
			case "admin":
				break;
			case "teacher":
				$uid = (is_object($xoopsUser)) ? $xoopsUser->getVar('uid') : -1;
				$sql .=  " Where " . $xoopsDB -> prefix("ctbt_contributions") . ".ctbt_teacher = '" . $uid . "'";
				break;
			default:
				$sql .= " Where " . $xoopsDB -> prefix("ctbt_contributions") . ".ctbt_state = '3'";
				break;
		}
		$result = $xoopsDB -> query($sql) or return_false();
		list($count) = $xoopsDB -> fetchRow($result);
		return $count;
	}

	function CheckSubmit($condition)
	{
		global $xoopsModuleConfig;

		$check_ltrim = ltrim($_POST["ctbt_title"]);
		if (empty($check_ltrim)) return false;
		$check_ltrim = ltrim($_POST["ctbt_author"]);
		if (empty($check_ltrim)) return false;
		$check_ltrim = ltrim($_POST["ctbt_realname"]);
		if (empty($check_ltrim)) return false;
		if ($xoopsModuleConfig['idno_address'])
		{
			$check_ltrim = ltrim($_POST["ctbt_idno"]);
			if (empty($check_ltrim)) return false;
			$check_ltrim = ltrim($_POST["ctbt_address"]);
			if (empty($check_ltrim)) return false;
		}
		switch ($condition)
		{
			case "exm":
				if ($_POST['ctbt_type'] == "txt")
				{
					$check_ltrim = ltrim($_POST["ctbt_contribution"]);
					if (empty($check_ltrim)) return false;
				}
				break;
			case "img":
				if (!is_uploaded_file($_FILES["ctbt_contribution"]["tmp_name"])) return false;
				$allowed_types = array("image/gif", "image/jpeg", "image/jpg", "image/pjpeg", "image/png");
				if (!in_array($_FILES["ctbt_contribution"]["type"], $allowed_types)) return false;
				if ($xoopsModuleConfig['filesize']) if ($_FILES["ctbt_contribution"]["size"] > $xoopsModuleConfig['filesize']) return false;
				$imgsize = getimagesize($_FILES["ctbt_contribution"]["tmp_name"]);
				if ($xoopsModuleConfig['imgsize_width']) if ($imgsize[0] > $xoopsModuleConfig['imgsize_width']) return false;
				if ($xoopsModuleConfig['imgsize_height']) if ($imgsize[1] > $xoopsModuleConfig['imgsize_height']) return false;
				break;
			default:
				$check_ltrim = ltrim($_POST["ctbt_contribution"]);
				if (empty($check_ltrim)) return false;
				break;
		}
		return true;
	}

	function SubmitContribution($type)
	{
		global $xoopsDB, $xoopsModuleConfig;
		$sql = "Insert Into " . $xoopsDB -> prefix("ctbt_contributions") . " (ctbt_state, ctbt_type, ctbt_title, ctbt_author, ctbt_realname, ctbt_idno, ctbt_address, ctbt_class, ctbt_teacher, ctbt_dttm, ctbt_exam_dttm) Values ('0', '" . $type . "', '" . htmlspecialchars($_POST["ctbt_title"]) . "', '" . htmlspecialchars($_POST["ctbt_author"]) . "', '" . htmlspecialchars($_POST["ctbt_realname"]) . "', '" . htmlspecialchars($_POST["ctbt_idno"]) . "', '" . htmlspecialchars($_POST["ctbt_address"]) . "', '" . $_POST["ctbt_grade"] . "-" . $_POST["ctbt_class"] . "', '" . $_POST["ctbt_teacher"] . "', '" . time() . "', '" . time() . "')";
		if (!$xoopsDB -> query($sql)) return false;

		$ctbt_id = $xoopsDB -> getInsertId();
		switch ($type)
		{
			case "img":
				$file_name = $ctbt_id;
				switch($_FILES["ctbt_contribution"]["type"])
				{
					case "image/gif":
						$file_name .= ".gif";
						break;
					case "image/jpeg":
						$file_name .= ".jpg";
						break;
					case "image/jpg":
						$file_name .= ".jpg";
						break;
					case "image/pjpeg":
						$file_name .= ".jpg";
						break;
					case "image/png":
						$file_name .= ".png";
						break;
				}
				$localfile = XOOPS_ROOT_PATH . $xoopsModuleConfig['uploadpath'] . "/" . $file_name;

				$sql = "Insert Into " . $xoopsDB -> prefix("ctbt_img") . " (ctbt_id, img_contribution) Values ('" . $ctbt_id . "', '" . $file_name . "')";
				if (!copy($_FILES["ctbt_contribution"]["tmp_name"], $localfile) || !($xoopsDB -> query($sql))){
					$sql = "Delete From " . $xoopsDB -> prefix("ctbt_contributions") . " Where ctbt_id = '" . $ctbt_id . "'";
					$xoopsDB -> query($sql);
					return false;
				}
				break;
			default:
				$sql = "Insert Into " . $xoopsDB -> prefix("ctbt_txt") . " (ctbt_id, txt_manuscript, txt_contribution) Values ('" . $ctbt_id . "', '" . $_POST["ctbt_contribution"] . "', '" . $_POST["ctbt_contribution"] . "')";
				if (!($xoopsDB -> query($sql)))
				{
					$sql = "Delete From " . $xoopsDB -> prefix("ctbt_contributions") . " Where ctbt_id = '" . $ctbt_id . "'";
					$xoopsDB -> query($sql);
					return false;
				}
				break;
		}
		return true;
	}

	function SetExamining($ctbt_id)
	{
		global $xoopsDB;
		$sql = "Update " . $xoopsDB -> prefix("ctbt_contributions") . " Set ctbt_state = '1' Where ctbt_id = '" . $ctbt_id . "'";
		if (!($xoopsDB -> queryF($sql))) return false;
		return true;
	}

	function ExamContribution($ctbt_id)
	{
		global $xoopsDB, $xoopsUser;
		$uid = is_object($xoopsUser) ? $xoopsUser->getVar('uid') : 0;
		$sql = "Update " . $xoopsDB -> prefix("ctbt_contributions") . " Set ctbt_state = '" . $_POST["ctbt_state"] . "', ctbt_title = '" . htmlspecialchars($_POST["ctbt_title"]) . "', ctbt_author = '" . htmlspecialchars($_POST["ctbt_author"]) . "', ctbt_realname = '" . htmlspecialchars($_POST["ctbt_realname"]) . "', ctbt_idno = '" . htmlspecialchars($_POST["ctbt_idno"]) . "', ctbt_address = '" . htmlspecialchars($_POST["ctbt_address"]) . "', ctbt_class = '" . $_POST["ctbt_grade"] . "-" . $_POST["ctbt_class"] . "', ctbt_teacher = '" . $uid . "', ctbt_comment = '" . $_POST["ctbt_comment"] . "', ctbt_exam_dttm = '" . time() . "' Where ctbt_id = '" . $ctbt_id . "'";
		if (!($xoopsDB -> query($sql))) return false;
		if ($_POST['ctbt_type'] == "txt") if (!($xoopsDB -> queryF("Update " . $xoopsDB -> prefix("ctbt_txt") . " Set txt_contribution = '" . $_POST["ctbt_contribution"] . "' Where ctbt_id = '" . $ctbt_id . "'"))) return false;
		return true;
	}

	function DeleteContribution($ctbt)
	{
		global $xoopsDB, $xoopsModuleConfig;
		$sql = "Delete From " . $xoopsDB -> prefix("ctbt_contributions") . " Where ctbt_id = '" . $ctbt['ctbt_id'] . "'";
		if (!($xoopsDB -> query($sql))) return false;
		$sql = ($ctbt['ctbt_type'] == "img") ? "Delete From " . $xoopsDB -> prefix("ctbt_img") . " Where ctbt_id = '" . $ctbt['ctbt_id'] . "'" : "Delete From " . $xoopsDB -> prefix("ctbt_txt") . " Where ctbt_id = '" . $ctbt['ctbt_id'] . "'";
		if (!($xoopsDB -> query($sql))) return false;
		if ($ctbt['ctbt_type'] == "img") if (file_exists(XOOPS_ROOT_PATH . "/" . $xoopsModuleConfig['uploadpath'] . "/" . $ctbt['ctbt_contribution'])) unlink(XOOPS_ROOT_PATH . "/" . $xoopsModuleConfig['uploadpath'] . "/" . $ctbt['ctbt_contribution']);
		return true;
	}
}
?>